org.apache.commons.io.output

## Class ChunkedOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - java.io.FilterOutputStream
    - - org.apache.commons.io.output.ChunkedOutputStream

All Implemented Interfaces:
  Closeable, Flushable, AutoCloseable

    public class ChunkedOutputStream
    extends FilterOutputStream

OutputStream which breaks larger output blocks into chunks. Native code may need to copy the input array; if the write buffer is very large this can cause OOME.

Since:
  2.5

### Field Summary

### Fields inherited from class java.io.FilterOutputStream

`out`

### Constructor Summary

Constructors
Constructor and Description
`ChunkedOutputStream(OutputStream stream)` Creates a new stream that uses a chunk size of `DEFAULT_CHUNK_SIZE`.
`ChunkedOutputStream(OutputStream stream, int chunkSize)` Creates a new stream that uses the specified chunk size.

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `write(byte[] data, int srcOffset, int length)` Writes the data buffer in chunks to the underlying stream

### Methods inherited from class java.io.FilterOutputStream

`close, flush, write, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### ChunkedOutputStream

    public ChunkedOutputStream(OutputStream stream,
                               int chunkSize)

Creates a new stream that uses the specified chunk size.

Parameters:
  `stream` - the stream to wrap
  `chunkSize` - the chunk size to use; must be a positive number.
Throws:
  `IllegalArgumentException` - if the chunk size is <= 0

#### ChunkedOutputStream

    public ChunkedOutputStream(OutputStream stream)

Creates a new stream that uses a chunk size of `DEFAULT_CHUNK_SIZE`.

Parameters:
  `stream` - the stream to wrap

### Method Detail

#### write

    public void write(byte[] data,
                      int srcOffset,
                      int length)
               throws IOException

Writes the data buffer in chunks to the underlying stream

Overrides:
  `write` in class `FilterOutputStream`
Parameters:
  `data` - the data to write
  `srcOffset` - the offset
  `length` - the length of data to write
Throws:
  `IOException` - if an I/O error occurs.